<template>
  <div class="myapps-iframe">
    <component :is="contentType()"  v-if="hackReset" :openParams="params" />
  </div>
</template>

<script>
import view_delegate from "@/components/view_delegate.vue"
import form_normalform from "@/components/form_normalform.vue"
import profile from "@/components/profile.vue"
import information from "@/components/information.vue"
import main_management from "@/components/main_management.vue"
import main_pending from "@/components/main_pending.vue"
import main_processing from "@/components/main_processing.vue"

export default {
  name: "obpm-open-container",
  props: ["openParams"],
  components: {
    view_delegate,
    form_normalform,
    profile,
    information,
    main_management,
    main_pending,
    main_processing
  },

  created() {
    this.doAction(this.openParams);
  },

  data: function() {
    return {
      params: null,
      paramsHistory: [],
      hackReset:true,
    };
  },

  methods: {
    //重建时加载
    reloading() {
      this.hackReset = false
      this.$nextTick(() => {
        this.hackReset = true
      })
    },
    contentType: function() {
      // this.params = openParams;
      let compName;
      switch (this.params.linkType) {
        case "00":
          //表单
          compName = "form_normalform";
          break;
        case "01":
          //列表视图
          compName = "view_delegate";
          break;
        case "02":
          //个人设置
          compName = "profile";
          break;
        case "03":
          //信息管理
          compName = "information";
          break;
        case "04":
          //系统设置
          compName = "main_management";
          break;
        case "05":
          //发起新建
          compName = "main_pending";
          break;
        case "06":
          //我的待办
          compName = "main_pending";
          break;
        case "07":
          //经办跟踪
          compName = "main_processing";
          break;
        case "08":
          //仪表分析
          compName = "main_pending";
          break;
        default:
          break;
      }
      return compName;
    },

    doAction: function(params) {
      this.paramsHistory.push(params);
      this.params = params;
    },

    doBack: function() {
      if (this.paramsHistory.length > 0) {
        this.paramsHistory.pop();
      }
      if (this.paramsHistory.length > 0) {
        this.params = this.paramsHistory[this.paramsHistory.length - 1];
      }else {
        this.$parent.onCloseBtnClick(this.params);
      }
    }
  }
};
</script>

